﻿/*
# 	Apprendre à programmer en ActionScript 3
# 	A. Tasso
# 	Chapitre 10: Le traitement de données multimédias
# 	Les Tweens
# 	Fichier : IconeTweener.fla
# 	Classe :  Icone.as 
*/



//Définition de la classe Icone
package {
	// importer les Tweener de caurina
	import caurina.transitions.*;
	// importer la classe Sprite et Loader
	import flash.display.*;
	// Importer la classe MouseEvent
	import flash.events.*;
	// Pour charger la classe URLRequest
	import flash.net.URLRequest;



	// Définition de la classe Icone
	public class Icone extends Sprite {

		private var photo:Loader;
		private var urlPhoto:String;
		private var info:InfoClp;

		// Définition de la fonction constructeur 
		public function Icone( nUrl:String) {
			setUrlPhoto(nUrl);
			setInfo();
			setPhoto();
		}
		public function setUrlPhoto(nUrl:String):void {
			urlPhoto = nUrl;
		}
		public function setInfo():void {
			info = new InfoClp();
			info.labelOut.text = urlPhoto;
			addChild(info);
			
			info.visible = false;
		}
		public function setPhoto():void {
			photo= new Loader();
			photo.load(new URLRequest(urlPhoto));
			photo.contentLoaderInfo.addEventListener(Event.COMPLETE, auComplet);
		}
		private function auComplet(evt:Event):void {
			addChildAt(photo,0);
			photo.content.x = -photo.width/2;
			photo.content.y = -photo.height/2;
			photo.addEventListener(MouseEvent.MOUSE_OVER, surOver);
			photo.addEventListener(MouseEvent.MOUSE_OUT, surOut);
		}
		private function surOver(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			Tweener.addTween(cible, {scaleX:1.2, scaleY:1.2, time:0.8, transition:"easeOutExpo", onComplete:afficheInfo});
		}
		
		private function surOut(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			Tweener.addTween(cible, {scaleX:1, scaleY:1, time:1, transition:"easeOutElastic", onComplete:effaceInfo});
		}
		
		private function afficheInfo():void {
			info.visible = true;
		}
		
		private function effaceInfo():void {
			info.visible = false;
		}
	}
}