﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 10 : Le traitement de données multimédia
# Projet Le mini site 
# Fichier : ChargeurPhotoAnimeVideo.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;
	import gs.TweenLite;
	import gs.easing.*;

	public class ChargeurPhotoAnimeVideo extends Sprite {
		// La photo, l'anime ou la vidéo  grand format
		public var grandFormat:MovieClip;
		// Info bulle
		public var bulleInfo:InfoBulleClp;
		// Photos, Animes ou Vidéos
		public var typeContenu:String;

		// Afficher les vignettes en ligne et en colonne
		private function afficheVignettes(nelt:uint,  nx:Number, ny:Number ) {
			var laVignette:PhotoClp;
			var tmp =  new Sprite();
			var ecartInterPhoto:uint = 10;
			var aCharger:Loader;
			var posX:uint = 0;
			var posY:uint = 0;
			var url:String;
			for (var i:uint = 0; i< nelt; i++) {
				url="../"+typeContenu+"/"+"vignette"+i+".jpg";
				aCharger = new Loader() ;
				laVignette = new PhotoClp();
				aCharger.load(new URLRequest(url));
				laVignette.scaleX = 0.7;
				laVignette.scaleY = 0.7;
				laVignette.x =(laVignette.width + ecartInterPhoto)*posX  + nx;
				laVignette.y = (laVignette.height + ecartInterPhoto)*posY + ny;
				laVignette.numero = i;
				laVignette.addChild(aCharger);
				posY++;
				if (laVignette.y  > MiniSite.hauteurPage) {
					posY=0;
					posX++;
				}
				tmp.addChildAt(laVignette,0);
				laVignette.addEventListener(MouseEvent.MOUSE_DOWN, surDown);
				laVignette.addEventListener(MouseEvent.MOUSE_UP, surUp);
				laVignette.addEventListener(MouseEvent.MOUSE_OVER, surOver);
				laVignette.addEventListener(MouseEvent.MOUSE_OUT, surOut);
			}
			addChild(tmp);
		}
		// Le constructeur de la classe ChargeurPhotoAnimeVideo()
		public function ChargeurPhotoAnimeVideo(rub:String,nelt:uint) {
			typeContenu=rub;
			afficheVignettes(nelt, 30, 180);
			bulleInfo=new InfoBulleClp()  ;
		}
		// Déplacer la vignette vers le bas quand on clique dessus
		private function surDown(e:MouseEvent):void {
			var cible:MovieClip=e.currentTarget  as  MovieClip;
			cible.x++;
			cible.y++;
		}
		// Déplacer la vignette vers le haut quand on relâche le bouton de la souris 
		private function surUp(e:MouseEvent):void {
			var cible:MovieClip=e.currentTarget  as  MovieClip;
			cible.x--;
			cible.y--;
			var url:String;
			switch (typeContenu) {
				case "Photos" :
					// Si c'est une photo, la charger en la déplaçant depuis la position courante de la souris jusqu'à la partie droite de la page
					url="../" + typeContenu + "/" + typeContenu + cible.numero + ".jpg";
					chargerPhotoOuAnim(url,parent.mouseX ,parent.mouseY ,MiniSite.largeurPage / 2 , MiniSite.finalYPage );
					break;
				case "Animes" :
					// Si c'est une animme, la charger en la déplaçant depuis la position courante de la souris jusqu'à la partie droite de la page
					url="../" + typeContenu + "/" + typeContenu + cible.numero + ".swf";
					chargerPhotoOuAnim(url,parent.mouseX ,parent.mouseY, MiniSite.largeurPage / 2 - 90, MiniSite.finalYPage);
					break;
				case "Videos" :
					// Si c'est une vidéo, la charger en la déplaçant depuis la position courante de la souris jusqu'à la partie droite de la page
					url="../" + typeContenu + "/" + typeContenu + cible.numero + ".flv";
					chargerVideo(url, parent.mouseX,parent.mouseY, MiniSite.largeurPage / 2 , 350);
					break;
			}
		}
		// Lorsque la souris survole une vignette, charger le fichier Infosxxx.txt, ou xxx correspond au numéro de la vignette
		private function surOver(e:MouseEvent):void {
			var cible:MovieClip=e.currentTarget  as  MovieClip;
			TweenLite.to(cible, 1, { alpha:0.4, ease:Strong.easeOut});
			//cible.alpha=0.4;
			cible.buttonMode=true;
			var infosTexte:URLLoader=new URLLoader;
			infosTexte.addEventListener(Event.COMPLETE,auChargement);
			infosTexte.load(new URLRequest("../" + typeContenu + "/" + "Infos" + cible.numero + ".txt"));
		}
		// Exraire l'information et afficher l'infobulle
		private function auChargement(e:Event):void {
			bulleInfo.labelOut.text=URLLoader(e.target).data;
			bulleInfo.x=parent.mouseX + 2;
			bulleInfo.y=parent.mouseY + 2;
			bulleInfo.fond.width=bulleInfo.labelOut.textWidth + 20;
			addChild(bulleInfo);
			bulleInfo.visible=true;
			e.target.removeEventListener(Event.COMPLETE,auChargement);
		}
		// Supprimer l'infobulle
		private function surOut(e:MouseEvent):void {
			var cible:MovieClip=e.currentTarget  as  MovieClip;
			TweenLite.to(cible, 1, { alpha:1, ease:Strong.easeOut});
			bulleInfo.visible = false;
		}
		// Description du chargement des photos ou des animes
		private function chargerPhotoOuAnim(url:String,nx:Number,ny:Number, fx:Number,fy:Number):void {
			if (grandFormat != null) {
				if (MiniSite.laVideo != null) {
					MiniSite.laVideo.remiseAZero();
					grandFormat.removeChild(MiniSite.laVideo);
				}
				removeChild(grandFormat);
			}
			var aCharger:Loader=new Loader;
			aCharger.load(new URLRequest(url));
			grandFormat=new MovieClip()  ;
			grandFormat.addChild(aCharger);

			grandFormat.x=nx - 32 ;
			grandFormat.y=ny - 47;
			grandFormat.scaleX=0.1;
			grandFormat.scaleY=0.1;

			grandFormat.finalY=fy;
			grandFormat.finalX=fx;
			grandFormat.alpha=0;
			addChild(grandFormat);
			grandFormat.addEventListener(Event.ENTER_FRAME,seDeplacerVers);
		}
		// Description du chargement des vidéos
		private function chargerVideo(url:String,nx:Number,ny:Number, fx:Number,fy:Number):void {
			if (grandFormat != null) {
				if (MiniSite.laVideo != null) {
					MiniSite.laVideo.remiseAZero();
					grandFormat.removeChild(MiniSite.laVideo);
				}
				removeChild(grandFormat);
			}
			grandFormat=new MovieClip()  ;
			MiniSite.laVideo=new LecteurVideo(url);
			grandFormat.addChild(MiniSite.laVideo);
			grandFormat.x=nx;
			grandFormat.y=ny;
			grandFormat.scaleX=0.1;
			grandFormat.scaleY=0.1;
			grandFormat.finalX=fx;
			grandFormat.finalY=fy;
			addChild(grandFormat);
			grandFormat.addEventListener(Event.ENTER_FRAME,seDeplacerVers);
		}
		// Les photos, animes ou videos au grand format se déplacent vers la droite de la page
		function seDeplacerVers(e:Event):void {
			var cible:MovieClip=e.currentTarget  as  MovieClip;
			var positionCouranteX,positionCouranteY;
			var ecartX,ecartY;
			var deplacementX,deplacementY;
			positionCouranteX=cible.x;
			positionCouranteY=cible.y;
			ecartX= cible.finalX - positionCouranteX;
			deplacementX=ecartX / 6;
			cible.x=positionCouranteX + deplacementX;
			ecartY=cible.finalY - positionCouranteY;
			deplacementY=ecartY / 6;
			cible.y=positionCouranteY  + deplacementY;
			cible.alpha+= 0.02;
			cible.scaleX+= 0.03;
			cible.scaleY+=0.03;

			if (Math.abs(deplacementY) < 0.4 && Math.abs(deplacementX) < 0.4) {
				cible.alpha=1;
				cible.x=cible.finalX;
				cible.y=cible.finalY;
				cible.scaleX=1;
				cible.scaleY=1;
				cible.removeEventListener(Event.ENTER_FRAME,seDeplacerVers);
			}
		}
	}// Fin de la classe classeurPhotos
}